"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TCPServer = void 0;
const net = __importStar(require("net"));
const tiny_typed_emitter_1 = require("tiny-typed-emitter");
class TCPServer extends tiny_typed_emitter_1.TypedEmitter {
    constructor(settings) {
        super();
        this.clients = [];
        this.settings = settings;
        this.server = net.createServer((socket) => {
            this.clients.push(socket);
            socket.on('data', (data) => {
                this.emit('data', data);
            });
            socket.on('error', (err) => {
                this.clients = this.clients.filter((client) => client !== socket);
            });
            socket.on('end', () => {
                this.clients = this.clients.filter((client) => client !== socket);
                this.emit('disconnected');
            });
            this.emit('connected');
        });
    }
    open(callback) {
        this.server.listen(this.settings.port);
        callback(null);
    }
    close() {
        this.clients.forEach((client) => {
            client.destroy();
        });
        this.removeAllListeners();
        this.clients = [];
        this.server.close();
        this.server.unref();
    }
    write(data, encoding, callback) {
        const promises = this.clients.map((client) => {
            return new Promise((resolve) => {
                client.write(data, encoding, () => {
                    resolve(null);
                });
            });
        });
        Promise.all(promises).then(() => {
            callback(null);
        }).catch((err) => {
            console.log('write error', err);
            callback(err);
        });
    }
}
exports.TCPServer = TCPServer;
//# sourceMappingURL=tcp-server.js.map